from __future__ import annotations
from typing import Any, Protocol, runtime_checkable

@runtime_checkable
class XPackage(Protocol):
    def createAbortChannel(self) -> XAbortChannel: ...
    def isBundle(self) -> bool: ...
    def getName(self) -> str: ...
    def getIdentifier(self) -> Optional<string>: ...
    def getURL(self) -> str: ...
    def getPackageType(self) -> XPackageTypeInfo: ...
    def getRepositoryName(self) -> str: ...
    def isRemoved(self) -> bool: ...
